/*
** jfile.c -- $@F|K\8l%F%-%9%H%U%!%$%k$NJ8;z%3!<%I$rH=Dj(B
*/

#include <stdio.h>

#define ASCII 0
#define KANJI 1

void error(int i) {
	fprintf(stderr, "Error Code = %d\n", i);
	fprintf(stderr, "Usage: jfile filename\n");
	exit(i);
}

void main(argc, argv) int argc; char *argv[]; {

	FILE *fp;
	char status = ASCII;
	int i, j, k = 0;

	fprintf(stderr, "KANJI DISCRIMINATION between JIS, EUC and Shift-JIS Ver. 1.0\n");
	switch(argc) {
		case 2:
			if((fp = fopen(argv[1], "rb")) == NULL) error(1);
			break;
		default:
			error(2);
			break;
	}

	/* JIS $@$H2>Dj$9$k(B */
	while((i = fgetc(fp)) != EOF) {
		if(i >= 0x80) goto JIS_QUIT;
		if(i == 0x1b) {
			j = fgetc(fp);
			switch(j) {
				case 0x24:
					if(status == ASCII) k++;
					status = KANJI;
					break;
				case 0x28:
					status = ASCII;
					break;
				default:
					break;
			}
		}
	}
	if(k > 0) {
		fprintf(stdout, "Maybe, %s is JIS text with %d KANJI parts\n", argv[1], k);
	} else {
		fprintf(stdout, "%s is not Japanese text\n", argv[1]);
	}
	fclose(fp);
	exit(0);

JIS_QUIT:
	fclose(fp);
	if((fp = fopen(argv[1], "rb")) == NULL) error(3);
	
	/* EUC $@$H2>Dj$9$k(B */
	while((i = fgetc(fp)) != EOF) {
		if(i >= 0x80 && i <= 0x9f) goto EUC_QUIT;
	}
	fprintf(stdout, "Maybe, %s is EUC text\n", argv[1]);
	fclose(fp);
	exit(0);

EUC_QUIT:
	fprintf(stdout, "Maybe, %s is Shift-JIS text\n", argv[1]);
	fclose(fp);
	exit(0);
}

